<template>
  <div class="root">
    <div class="header">
      <h2>
        Radio Control
      </h2>
      <h3>
        {{ subtitle }}
      </h3>
      <h6 v-if="!connected">
        Is someone hogging the speaker? Try pushing the speaker's<br>
        scan button and then attempt to connect!
      </h6>
    </div>
    <div :class="'controls '+orientation" v-if="connected">
      <div v-if="connected" :class="'control-buttons '+orientation">
        <button class="mdc-icon-button material-icons" @click=quiet>volume_down</button>
        <button class="mdc-icon-button material-icons" @click=louder>volume_up</button>
        <button class="mdc-icon-button mdc-icon-button__toggle
          material-icons" :aria-pressed="muted" @click=toggleMute>
          <i class="material-icons mdc-icon-button__icon
            mdc-icon-button__icon--on">volume_mute</i>
          <i class="material-icons mdc-icon-button__icon">volume_mute</i>
        </button>
      </div>
      <div class="stations-container" v-if="stations != [] && connected">
        <button :key="station" v-for="station in sortedStations"
          class="mdc-button mdc-button--raised station-button"
          @click="play" :id="station">
          <div class="mdc-button__ripple"></div>
          <span class="mdc-button__label">{{station}}</span>
        </button>
      </div>
      <div v-if="connected" :class="'control-buttons '+orientation">
        <button class="mdc-icon-button material-icons" @click=disconnect>
          bluetooth_disabled
        </button>
        <button class="mdc-icon-button material-icons" @click=kill>
          stop
        </button>
        <button class="mdc-icon-button material-icons" @click=updateStatus>
          refresh
        </button>
      </div>
    </div>
    <div v-else>
      <button class="mdc-icon-button material-icons" @click=connect>
         bluetooth
      </button>
    </div>
    <div class="mdc-snackbar">
      <div class="mdc-snackbar__surface">
        <div class="mdc-snackbar__label" role="status" aria-live="polite">
        </div>
        <div class="mdc-snackbar__actions">
          <button class="mdc-icon-button mdc-snackbar__dismiss material-icons"
            title="Dismiss">close</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import http from 'http'
import {MDCRipple} from '@material/ripple'
import {MDCIconButtonToggle} from '@material/icon-button'
import {MDCSnackbar} from '@material/snackbar'

const backend = window.env['BACKEND_BASE_URL']
const volumeStep = 5

export default {
  name: 'control',
  data() {
    return {
      volume: null,
      muted: false,
      connected: null,
      stations: [],
      orientation: "",
      snackbar: undefined,
    }
  },
  computed: {
    sortedStations: function() {
      let sortedStations = this.stations.slice()
      return sortedStations.sort()
    },
    subtitle: function() {
      if (this.connected == false) {
        return "We are not connected : ("
      } else if (this.connected === null) {
        return "checking connection status..."
      }
      let title = `Volume: ${this.volume}%`
      if (this.muted) {
        title += " - muted!"
      }
      return title
    },
    muteButtonClass: function() {
      if (this.muted) {
        return "is-info"
      }
      return ""
    },
    toggleMuteIcon: function() {
      if (this.muted) {
        return "music-note"
      }
      return "music-note-off"
    },
  },
  methods: {
    getJSON: function (url, callback) {
      return new Promise((resolve, reject) => {
        const req = http.get(url, res => {
          const { statusCode } = res
          if (statusCode === 204) {
            resolve()
            return
          }
          res.setEncoding('utf8')
          let rawData = ''
          res.on('data', (chunk) => { rawData += chunk })
          res.on('end', () => {
            try {
              const parsedData = JSON.parse(rawData)
              if (Math.floor(statusCode/100) != 2) {
                let errMsg = `Request for ${url} failed.\n` +
                              `Status Code: ${statusCode}`
                if (parsedData != null) {
                  const receivedError = parsedData.error.split("\n")[0]
                  errMsg += `\nReceived error: ${receivedError}`
                }
                const error = new Error(errMsg)
                this.handleError(error)
                reject(error)
                return
              } else {
                if (callback !== undefined) {
                  callback(parsedData)
                }
                resolve(parsedData)
                return
              }
            } catch (e) {
              this.handleError(e.message)
              reject(e)
              return
            }
          })
        })
        req.on('error', e => {
            this.handleError(e.message)
            reject(e)
        })
        req.end()
      })
    },
    handleError: function(err) {
      this.snackbar.labeltext = `${err}`
      this.snackbar.open()
    },
    unfocus: function(event) {
      if (event.clientX != 0 && event.clientY != 0) {
        const element = event.target
        element.blur()
        element.parentElement.blur()
      }
    },
    orient: function() {
      const angle = screen.orientation === undefined ? window.orientation :
        screen.orientation.angle
      if (angle % 180 == 0) {
        this.orientation = "portrait"
      } else {
        this.orientation = "landscape"
      }
    },
    changeVolume: function(amount, louder) {
      const endpoint = louder ? "louder" : "quiet"
      const url = `${backend}/${endpoint}/${amount}`
      return this.getJSON(url)
    },
    getStations: function() {
      return this.getJSON(backend+'/stations', data => {
        this.stations = data;
      })
    },
    toggleMute: function(event) {
      this.getJSON(`${backend}/mute`).then( _ => { this.checkMuteStatus()})
      this.unfocus(event)
    },
    quiet: function(event) {
      this.changeVolume(volumeStep, false)
      this.updateVolume()
      this.unfocus(event)
    },
    louder: function(event) {
      this.changeVolume(volumeStep, true)
      this.updateVolume()
      this.unfocus(event)
    },
    play: function(event) {
      this.unfocus(event)
      const station = event.target.parentElement.id
      this.kill().then(_ => { this.getJSON(`${backend}/play/${station}`)})
    },
    kill: function(event) {
      if (event !== undefined) {
        this.unfocus(event)
      }
      return this.getJSON(`${backend}/kill`)
    },
    async disconnect(event) {
      this.unfocus(event)
      await this.getJSON(`${backend}/disconnect`)
      this.updateStatus()
    },
    async connect(event) {
      this.unfocus(event)
      await this.getJSON(`${backend}/connect`)
      this.updateStatus()
    },
    updateVolume() {
      return this.getJSON(backend+'/volume', data => {
        this.volume = data.volume
      })
    },
    checkMuteStatus() {
      return this.getJSON(`${backend}/muted`, data => {
        this.muted = data.muted
      })
    },
    checkConnection() {
      return this.getJSON(backend+'/connected', data => { this.connected = data.connected })
    },
    updateStatus(event) {
      if (event !== undefined) {
        this.unfocus(event)
      }
      this.checkConnection().then( async _ => {
        if (this.connected) {
          await this.updateVolume()
          await this.checkMuteStatus()
          await this.getStations()
          this.doMaterialStuff()
        }
      })
    },
    doMaterialStuff() {
      let iconButtons = document.querySelectorAll('.mdc-icon-button')
      iconButtons.forEach(button => {
        const iconButtonRipple = new MDCRipple(button)
        iconButtonRipple.unbounded = true;
      })

      let buttons = document.querySelectorAll('.mdc-button')
      buttons.forEach(button => {
        const buttonRipple = new MDCRipple(button)
        buttonRipple.unbounded = true;
      })

      new MDCIconButtonToggle(document.querySelector('.mdc-icon-button__toggle'))

      if (this.snackbar === undefined) {
        this.snackbar = new
          MDCSnackbar(document.querySelector('.mdc-snackbar'))
        this.snackbar.timeoutMs = 4000
      }
    }
  },
  mounted() {
    this.updateStatus()
  },
  created() {
    window.addEventListener('orientationchange', this.orient)
    this.orient()
  }
}
</script>

<style lang=scss>
  @use "@material/button/mdc-button";
  @use "@material/button/mixins" as buttonmix;
  @use "@material/icon-button/mdc-icon-button";
  @use "@material/icon-button/mixins" as icbut;
@use "@material/snackbar/mdc-snackbar";

  .mdc-button {
    //@include buttonmix.height(44px);
  }

  .mdc-icon-button {
    @include icbut.icon-size(36px);
    @include icbut.ink-color(green);
  }

  .mdc-icon-button__toggle i {
    font-size: 36px;
  }

  body {
   height: 100%;
  }

  .stations-container {
    margin-left: 30px;
    margin-right: 30px;
    max-width: 320px;
  }
  .station-button {
    margin: 5px;
  }

  html,body,#app {
    height: 100%;
    max-height: 667px;
  }

  .root {
    height: 100%;
    display: flex;
    flex-flow: column;
  }

  .controls {
    display: flex;
    align-items: center;
    justify-content: space-between;

    flex: 1;
    padding-left: 20px;
    padding-right: 20px;
  }
  .controls.landscape {
    flex-direction: row;
  }
  .controls.portrait {
    flex-direction: column;
    padding-bottom: 56px;
  }

  .control-buttons .mdc-icon-button {
    padding: 0px;
  }

  .control-buttons {
    display: flex;
  }
  .control-buttons.landscape {
    flex-direction: column;
  }
  .control-buttons.portrait {
    flex-direction: row;
  }

  h2 {
    margin-top: 10px;
    margin-bottom: 10px;
  }

  h3 {
    margin-top: 10px;
    margin-bottom: 10px;
  }
</style>
